SystemOrganization addCategory: #'SqueakNxt-Etoys'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Player'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Bars'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-ControlPanel'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Ports'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Wiring'!

PolygonMorph subclass: #LittleArrowMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!LittleArrowMorph class methodsFor: 'instance creation' stamp: 'Richo 10/7/2008 17:05'!
leftArrow
	^ self
		vertices: {-5 @ 0. 0 @ 5. 0 @ -5}
		color: Color black
		borderWidth: 0
		borderColor: Color black! !

!LittleArrowMorph class methodsFor: 'instance creation' stamp: 'Richo 10/6/2008 18:50'!
rightArrow
	^ self
		vertices: {5 @ 0. 0 @ 5. 0 @ -5}
		color: Color black
		borderWidth: 0
		borderColor: Color black! !

!LittleArrowMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/6/2008 18:52'!
step
	self color = Color black
		ifTrue: [self color: Color transparent]
		ifFalse: [self color: Color black]! !

!LittleArrowMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/6/2008 18:54'!
stepTime
	^ self color = Color black
		ifTrue: [900]
		ifFalse: [300]! !

PolygonMorph subclass: #NxtButtonMorph
	instanceVariableNames: 'originalColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:31'!
cancelButton
	| verts |
	verts := {0 @ 0. 30 @ 0. 30 @ 25. 0 @ 25}.
	^ (self
		vertices: verts
		color: (Color gray mixed: 0.5 with: Color white)
		borderWidth: 3
		borderColor: Color black)! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
leftButton
	| verts |
	verts := {0 @ 0. 0 @ 34. -25 @ 17}.
	^ self
		vertices: verts
		color: Color gray muchLighter
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
okButton
	| verts |
	verts := {0 @ 0. 0 @ 35. 35 @ 35. 35 @ 0}.
	^ self
		vertices: verts
		color: Color orange
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
rightButton
	| verts |
	verts := {0 @ 0. 0 @ 34. 25 @ 17}.
	^ self
		vertices: verts
		color: Color gray muchLighter
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:35'!
vertices: verts color: c borderWidth: bw borderColor: bc 
	^ (super
		vertices: verts
		color: c
		borderWidth: bw
		borderColor: bc) initialize! !

!NxtButtonMorph methodsFor: 'initialization' stamp: 'Richo 10/2/2008 16:35'!
initialize
	"No hacer 'super initialize' porque dibuja un triangulito"
	originalColor := self color.
	self
		on: #mouseEnter
		send: #mouseEnter:forMorph:
		to: self;
		
		on: #mouseLeave
		send: #mouseLeave:forMorph:
		to: self! !

!NxtButtonMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:35'!
mouseEnter: evt forMorph: aMorph 

	self color: originalColor muchLighter! !

!NxtButtonMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:33'!
mouseLeave: evt forMorph: aMorph 
	self color: originalColor! !

PEWireMorph subclass: #SqueakNxtWireMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Wiring'!

!SqueakNxtWireMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 1/31/2011 17:15'!
validConnectionClasses
	^ super validConnectionClasses, {PortMorph}! !

!SqueakNxtWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/11/2009 14:35'!
initialize
super initialize.
self lineColor: Color black; lineWidth: 10; beSmoothCurve; beOrthogonal: true! !

Player subclass: #SqueakNxtPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Player'!

!SqueakNxtPlayer class methodsFor: 'note contants' stamp: 'Richo 1/13/2011 16:07'!
frequencyFor: noteName
	^ self frequencyFor: noteName ifAbsent: [0]! !

!SqueakNxtPlayer class methodsFor: 'note contants' stamp: 'Richo 1/13/2011 16:06'!
frequencyFor: noteName ifAbsent: aBlock
	^ (self notes as: Dictionary) at: noteName ifAbsent: aBlock! !

!SqueakNxtPlayer class methodsFor: 'class initialization' stamp: 'Richo 1/27/2011 14:19'!
initialize
	"
	self initialize.
	"
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #NxtNote; symbols: self noteNames).! !

!SqueakNxtPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:17'!
isUniClass
	^ self ~~ self officialClass! !

!SqueakNxtPlayer class methodsFor: 'note contants' stamp: 'Richo 1/13/2011 15:39'!
noteNames
	^ self notes collect: [:each | each key]! !

!SqueakNxtPlayer class methodsFor: 'note contants' stamp: 'Richo 1/13/2011 15:39'!
notes
	^  {#A3->220 . #'A#3'->233 . #B3->247 . #C4->262 . #'C#4'->277 . #D4->294 . #'D#4'->311 . #E4->330 . #F4->349 . #'F#4'->370 . #G4->392 . #'G#4'->415 . #A4->440 . #'A#4'->466 . #B4->494 . #C5->523 . #'C#5'->554 . #D5->587 . #'D#5'->622 . #E5->659 . #F5->698 . #'F#5'->740 . #G5->784 . #'G#5'->831 . #A5->880 . #'A#5'->932 . #B5->988 . #C6->1047 . #'C#6'->1109 . #D6->1175 . #'D#6'->1245 . #E6->1319 . #F6->1397 . #'F#6'->1480 . #G6->1568 . #'G#6'->1661 . #A6->1760 . #'A#6'->1865 . #B6->1976 . #C7->2093 . #'C#7'->2217 . #D7->2349 . #'D#7'->2489 . #E7->2637 . #F7->2794 . #'F#7'->2960 . #G7->3136 . #'G#7'->3322 . #A7->3520 . #'A#7'->3729 . #B7->3951}! !

!SqueakNxtPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:17'!
officialClass
	^ SqueakNxtPlayer! !

!SqueakNxtPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:17'!
wantsChangeSetLogging
	"Log changes for Player itself, but not for automatically-created subclasses like Player1, Player2, but *do* log it for uniclasses that have been manually renamed."

	^ (self == self officialClass or:
		[(self name beginsWith: self officialClass asString) not]) or:
			[Preferences universalTiles]! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:13'!
brake
	^ self sendMessageToCostume: #brake! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:44'!
clearScreen
	"Do nothing. Command not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 13:17'!
connect
	^ self sendMessageToCostume: #connect! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 13:17'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:44'!
displayNumber: aNumber
	"Do nothing. Command not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:44'!
displayText: aString
	"Do nothing. Command not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'timer' stamp: 'Richo 1/27/2011 15:28'!
firstTick
	^ self costume renderedMorph valueOfProperty: #firstTick ifAbsentPut: [Time millisecondClockValue]! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:13'!
float
	^ self sendMessageToCostume: #float! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:20'!
getActive
	^ (self sendMessageToCostume: #active) ifNil: [false]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:20'!
getAudible
	^ (self sendMessageToCostume: #audible) ifNil: [false]! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:13'!
getAutomaticBrake
	^ (self sendMessageToCostume: #automaticBrake) ifNil: [false]! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 13:17'!
getBatteryLevel
	^ (self sendMessageToCostume: #batteryLevel) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:22'!
getConnection
	^ self costume renderedMorph valueOfProperty: #connection ifAbsent: [0]! !

!SqueakNxtPlayer methodsFor: 'timer' stamp: 'Richo 3/27/2012 13:18'!
getCurrentTick
	(self getIsConnected and: [self isUsingCompiledMode not])
		ifFalse: [self resetTimer. ^0].
	
	^ Time millisecondClockValue - self firstTick! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:14'!
getDegrees
	^ (self sendMessageToCostume: #rotation) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:46'!
getDisplayX
	^ self costume renderedMorph valueOfProperty: #displayX ifAbsent: [0]! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:45'!
getDisplayY
	^ self costume renderedMorph valueOfProperty: #displayY ifAbsent: [0]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 1/4/2011 14:32'!
getDistanceCm
	^ self getRawValue! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 1/27/2011 14:50'!
getDuration
	^ self costume renderedMorph valueOfProperty: #soundDuration ifAbsent: [200]! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 12:36'!
getIsConnected
	^ (self sendMessageToCostume: #isConnected) ifNil: [false]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:20'!
getIsPressed
	^ (self sendMessageToCostume: #isPressed) ifNil: [false]! !

!SqueakNxtPlayer methodsFor: 'nxt buttons' stamp: 'Richo 1/27/2011 19:12'!
getIsPressedEnter
	"Not supported in direct mode"
	^ false! !

!SqueakNxtPlayer methodsFor: 'nxt buttons' stamp: 'Richo 1/27/2011 19:12'!
getIsPressedLeft
	"Not supported in direct mode"
	^ false! !

!SqueakNxtPlayer methodsFor: 'nxt buttons' stamp: 'Richo 1/27/2011 19:12'!
getIsPressedRight
	"Not supported in direct mode"
	^ false! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:23'!
getMailBox
	^ self costume renderedMorph valueOfProperty: #mailBox ifAbsent: [1]! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
getMsgBoolean
	"Not supported in direct mode"
	^ false! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
getMsgNumber
	"Not supported in direct mode"
	^ 0! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
getMsgText
	"Not supported in direct mode"
	^ ''! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:20'!
getNormalizedValue
	^ (self sendMessageToCostume: #normalizedValue) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 13:17'!
getNxtPort
	^ (self sendMessageToCostume: #portName) ifNil: ['']! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:14'!
getPower
	^ (self sendMessageToCostume: #power) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:20'!
getRawValue
	^ (self sendMessageToCostume: #rawValue) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:21'!
getScaledValue
	^ (self sendMessageToCostume: #scaledValue) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:21'!
getValue
	^ (self sendMessageToCostume: #value) ifNil: [0]! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 1/27/2011 14:50'!
getVolume
	^ self costume renderedMorph valueOfProperty: #soundVolume ifAbsent: [2]! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 3/27/2012 13:25'!
playNote: aSymbol
	self playTone: (self class
				frequencyFor: aSymbol
				ifAbsent: [])! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 3/27/2012 13:24'!
playSoundFile: aString
	^ self sendMessageToCostume: #playSoundFile: with: aString! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 3/27/2012 13:25'!
playTone: aSymbol
	(self costumeRespondingTo: #playTone:duration:)
		ifNotNil: [:morph |
			morph
				playTone: aSymbol
				duration: self getDuration ]! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:14'!
resetDegrees
	^ self sendMessageToCostume: #resetRelative: with: true! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 14:44'!
resetScreen
	"Do nothing. Command not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'timer' stamp: 'Richo 1/27/2011 16:49'!
resetTimer
	self costume renderedMorph removeProperty: #firstTick! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:21'!
setActive: aBoolean 
	^ self sendMessageToCostume: #active: with: aBoolean! !

!SqueakNxtPlayer methodsFor: 'sensors' stamp: 'Richo 3/27/2012 13:21'!
setAudible: aBoolean 
	^ self sendMessageToCostume: #audible: with: aBoolean! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:14'!
setAutomaticBrake: aBoolean 
	self sendMessageToCostume: #automaticBrake: with: aBoolean! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:23'!
setConnection: aNumber 
	self costume renderedMorph setProperty: #connection toValue: aNumber \\ 4! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 15:14'!
setDisplayX: aNumber 
	self costume renderedMorph setProperty: #displayX toValue: (aNumber min: 99 max: 0)! !

!SqueakNxtPlayer methodsFor: 'display' stamp: 'Richo 1/27/2011 15:14'!
setDisplayY: aNumber 
	self costume renderedMorph setProperty: #displayY toValue: (aNumber min: 63 max: 0)! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 1/27/2011 14:50'!
setDuration: aNumber
	self costume renderedMorph setProperty: #soundDuration toValue: aNumber! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:23'!
setMailBox: aNumber 
	self costume renderedMorph setProperty: #mailBox toValue: aNumber - 1 \\ 10 + 1! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
setMsgBoolean: aBoolean 
	"Not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
setMsgNumber: aNumber
	"Not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'send/receive' stamp: 'Richo 1/27/2011 15:24'!
setMsgText: aString
	"Not supported in direct mode"! !

!SqueakNxtPlayer methodsFor: 'connection' stamp: 'Richo 3/27/2012 13:18'!
setNxtPort: aSymbol
	^ self sendMessageToCostume: #portName: with: aSymbol! !

!SqueakNxtPlayer methodsFor: 'motor' stamp: 'Richo 3/27/2012 13:15'!
setPower: aNumber 
	self sendMessageToCostume: #power: with: aNumber! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 1/27/2011 14:50'!
setVolume: aNumber
	self costume renderedMorph setProperty: #soundVolume toValue: aNumber \\ 5! !

!SqueakNxtPlayer methodsFor: 'other stuff' stamp: 'Richo 3/27/2012 13:25'!
startProgram: aString 
	^ self sendMessageToCostume: #startProgram: with: aString! !

!SqueakNxtPlayer methodsFor: 'sound' stamp: 'Richo 3/27/2012 13:25'!
stopPlaying
	self sendMessageToCostume: #stopPlayingSound! !

!SqueakNxtPlayer methodsFor: 'other stuff' stamp: 'Richo 3/27/2012 13:26'!
stopProgram
	^ self sendMessageToCostume: #stopProgram! !

Morph subclass: #ControlPanelMorph
	instanceVariableNames: 'display main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!ControlPanelMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 16:04'!
on: aLegoNxtMorph 
^self basicNew setMain: aLegoNxtMorph; initialize! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:55'!
cancelClick
	^ display cancelClick! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:54'!
initialize
	super initialize.
	self
		color: (Color
				r: 0.936
				g: 0.936
				b: 0.936);
		 borderColor: Color black;
		 borderWidth: 2;
		 height: 260;
		 width: 200.
	self initializeSubmorphs! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeCancelButton
	| cancelButton |
	cancelButton := NxtButtonMorph cancelButton.
	cancelButton center: self center x @ (self center y + (cancelButton height * 2));
		
		on: #mouseDown
		send: #cancelClick
		to: self.
	self addMorph: cancelButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:06'!
initializeDisplay
	display := NxtDisplayMorph on: main.
	display center: self center x @ (self center y - (display height // 1.5)).
	self addMorph: display! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeLeftButton
	| leftButton |
	leftButton := NxtButtonMorph leftButton.
	leftButton center: self center x - leftButton height @ (self center y + (leftButton height // 2));
		
		on: #mouseDown
		send: #leftClick
		to: self.
	self addMorph: leftButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeOkButton
	| okButton |
	okButton := NxtButtonMorph okButton.
	okButton center: self center x @ (self center y + (okButton height // 2));
		
		on: #mouseDown
		send: #okClick
		to: self.
	self addMorph: okButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:47'!
initializeRightButton
	| rightButton |
	rightButton := NxtButtonMorph rightButton.
	rightButton center: self center x + rightButton height @ (self center y + (rightButton height // 2));
		
		on: #mouseDown
		send: #rightClick
		to: self.
	self addMorph: rightButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 4/13/2012 15:56'!
initializeString
	| string |
	string := 'NXT' asMorph fontName: 'Accuat' size: 18.
	string left: self left + 10;
		 bottom: self bottom - 5.
	self addMorph: string! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:44'!
initializeSubmorphs
	self initializeOkButton;initializeCancelButton;initializeLeftButton;initializeRightButton;initializeDisplay;initializeString
	! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
leftClick
	^ display leftClick! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
okClick
	^ display okClick! !

!ControlPanelMorph methodsFor: 'accessing' stamp: 'Richo 3/26/2012 16:02'!
portName: aSymbol
	display portName: aSymbol! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/26/2012 16:17'!
resetDisplay
	display resetSubmorphs
! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
rightClick
	^ display rightClick! !

!ControlPanelMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 16:05'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

!ControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 3/26/2012 16:01'!
step
	self resetDisplay! !

!ControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 3/26/2012 16:01'!
stepTime
	^ 500! !

Morph subclass: #NxtDisplayMorph
	instanceVariableNames: 'portIndex portNumber main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!NxtDisplayMorph class methodsFor: 'constants' stamp: 'Richo 10/7/2008 18:27'!
maximumPortNumber
^10! !

!NxtDisplayMorph class methodsFor: 'constants' stamp: 'Richo 10/7/2008 18:29'!
minimumPortNumber
	^ 1! !

!NxtDisplayMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 16:06'!
on: aLegoNxtMorph
^self basicNew setMain: aLegoNxtMorph; initialize! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:17'!
cancelClick
	main disconnect.
	self resetSubmorphs! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 18:00'!
currentPortName
"Si no lo encuentra, devuelvo el que tiene seteado main. En caso de ser cero no lo va a encontrar porque significa que el puerto lo escribi el usuario"
^self portNames at: portIndex ifAbsent: [main portName]! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 10/6/2008 18:58'!
deleteSubmorphs
	self
		submorphsDo: [:each | each delete]! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 17:22'!
initialize
	super initialize.
	self extent: 135 @ 80;
		
		color: (Color
				r: 0.823
				g: 0.948
				b: 0.63);
		 borderWidth: 3;
		 borderColor: Color black.
	portIndex := 1.
	self initializeSubmorphsDisconnected! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 4/6/2011 11:14'!
initializeConnectionLabelMorph
	| s1 |
	s1 := 'Port:' translated asMorph fontName: 'BitstreamVeraSans' size: 18;
				 emphasis: 1;
				 center: self center.
	self addMorphBack: s1.! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 11/10/2009 18:01'!
initializeConnectionPortNameMorph
	"Si el portIndex es cero, el puerto lo escribi el usuario. No muestro las flechitas"
	| s2 |
	s2 := self currentPortName asMorph fontName: 'BitstreamVeraSans' size: 18;
				 
				 center: self center x @ (self center y + 20).
	self addMorphBack: s2.
	portIndex = 0
		ifTrue: [^self].
	portIndex > 1
		ifTrue: [self addMorphBack: (LittleArrowMorph leftArrow center: s2 leftCenter - (10@0))].
	portIndex < self portNames size
		ifTrue: [self addMorphBack: (LittleArrowMorph rightArrow center: s2 rightCenter + (10@0))]! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 10/6/2008 18:45'!
initializeConnectionStateMorph
	| stringMorph |
	stringMorph := '<' asMorph fontName: 'Accuat' size: 18.
	stringMorph position: self position + 5.
	self addMorphBack: stringMorph! !

!NxtDisplayMorph methodsFor: 'initialize connected' stamp: 'Richo 10/7/2008 17:14'!
initializeSubmorphsConnected
	| pl pr |
	pl := (PolygonMorph
				vertices: {0 @ -20. -20 @ 0. 0 @ 20}
				color: Color black
				borderWidth: 3
				borderColor: Color black) makeOpen center: self center;
				 right: self center x.
	pr := (PolygonMorph
				vertices: {0 @ -20. 20 @ 0. 0 @ 20}
				color: Color black
				borderWidth: 3
				borderColor: Color black) makeOpen center: self center;
				 left: self center x.
	self addMorphBack: pl;
		 addMorphBack: pr! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 17:17'!
initializeSubmorphsConnected: aBoolean
aBoolean 
	ifTrue: [self initializeSubmorphsConnected]
	ifFalse: [self initializeSubmorphsDisconnected]! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 11/10/2009 17:22'!
initializeSubmorphsDisconnected
	self initializeConnectionStateMorph.
	self initializeConnectionLabelMorph.
	self initializeConnectionPortNameMorph.! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:38'!
keepIndexInsideBoundaries
	portIndex >= self portNames size
		ifTrue: [portIndex := self portNames size].
	portIndex <= 1
		ifTrue: [portIndex := 1].! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:46'!
leftClick
	portIndex := portIndex - 1.
	self keepIndexInsideBoundaries.
	self resetSubmorphs.
	main portName: self currentPortName.! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 18:00'!
okClick
	main portName: self currentPortName; connect.
	self resetSubmorphs! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 17:48'!
portName: aSymbol
portIndex := self portNames indexOf: aSymbol ifAbsent: [0].
self resetSubmorphs ! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 3/26/2012 16:18'!
portNames
	^ PESerialPort availablePortsForNxt select: [:each |
			each beginsWithAnyOf: #('USB' 'COM')]! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:07'!
resetSubmorphs
	self deleteSubmorphs.
	self initializeSubmorphsConnected:  main isConnected! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:46'!
rightClick
	portIndex := portIndex + 1.
	self keepIndexInsideBoundaries.
	self resetSubmorphs.
	main portName: self currentPortName.! !

!NxtDisplayMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 16:07'!
setMain: aLegoNxtMorph
main := aLegoNxtMorph! !

Morph subclass: #PortMorph
	instanceVariableNames: 'originalColor port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

PortMorph subclass: #MotorPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

!MotorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:25'!
myDevice
^NxtMotorMorph new! !

!MotorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:21'!
wantedDroppedMorphClasses
	"Devuelve un array con las clases que pueden conectarse a este puerto"
	^ Array with: NxtMotorMorph ! !

!MotorPortMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 12:58'!
defaultPositions
	^ ({-200 @ -100. 180 @ -250. 200 @ -100}
		collect: [:each | each + self center])
		at: port portNumber! !

!MotorPortMorph methodsFor: 'accessing' stamp: 'Richo 10/7/2008 15:19'!
letters
	^ #('A' 'B' 'C' )! !

!PortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:25'!
myDevice
	"Devuelve un morph para conectarse a este puerto. En el caso de los sensores debera preguntar al usuario que tipo de sensor quiere conectar"
	^ self subclassResponsibility! !

!PortMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:46'!
port: aPort
	^ self basicNew setPort: aPort;
		 initialize! !

!PortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:21'!
wantedDroppedMorphClasses
"Devuelve un array con las clases que pueden conectarse a este puerto"
^self subclassResponsibility! !

!PortMorph methodsFor: 'dropping' stamp: 'Richo 2/16/2009 16:00'!
acceptDroppingMorph: aMorph event: evt 
	"No se porqu desaparece el morph antes de llegar ac, por eso le mando
	openInWorld"
	aMorph openInWorld.
self plug: aMorph! !

!PortMorph methodsFor: 'accessing' stamp: 'Richo 10/15/2008 15:20'!
defaultPositions
"Devuelve un array con las posiciones para cada motor o sensor"
self subclassResponsibility! !

!PortMorph methodsFor: 'initializing' stamp: 'Richo 10/6/2008 16:10'!
initialize
	super initialize.
	self
		color: (Color gray mixed: 0.5 with: Color white);
		 borderColor: Color black;
		 borderWidth: 2;
		 height: 30.
	originalColor := self color.
	self
		on: #mouseEnter
		send: #mouseEnter:forMorph:
		to: self;
		
		on: #mouseLeave
		send: #mouseLeave:forMorph:
		to: self.
	self on: #mouseDown send: #mouseDown:forMorph: to: self.
	self initializeLetterMorph! !

!PortMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:47'!
initializeLetterMorph
	| letterMorph |
	letterMorph := (self letters at: port portNumber) asMorph fontName: 'BitstreamVeraSans' size: 22;
				 emphasis: 1;
				 center: self center.
	self addMorph: letterMorph! !

!PortMorph methodsFor: 'accessing' stamp: 'Richo 10/10/2008 17:01'!
letters
	"Devuelve un Array de strings para cada valor de 1 a 4 (en el caso de los motores de 1 a 3)"
	self subclassResponsibility! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 2/16/2009 14:48'!
mouseDown: evt forMorph: aMorph 
	"No debera funcionar si ya tengo un motor o sensor conectado"
	self plugNewDevice! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:37'!
mouseEnter: evt forMorph: aMorph 
	self color: originalColor muchLighter! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:37'!
mouseLeave: evt forMorph: aMorph 
	self color: originalColor! !

!PortMorph methodsFor: 'plugging' stamp: 'Richo 11/10/2009 12:38'!
plug: aConectableDeviceMorph 
	| connector |
connector := (SqueakNxtWireMorph fromMorph: self toMorph: aConectableDeviceMorph attachmentPoint).
	aConectableDeviceMorph connector: connector.
	aConectableDeviceMorph device plugOn: port.
	aConectableDeviceMorph moveTo: self defaultPositions! !

!PortMorph methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:21'!
plugNewDevice
	| newDevice |
	port isBusy ifTrue: [^self].
	newDevice := self class myDevice.
	newDevice isNil
		ifTrue: [^ self].
	newDevice center: self center.
	newDevice openInWorld.
	self plug: newDevice! !

!PortMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:46'!
setPort: aPort
port := aPort! !

!PortMorph methodsFor: 'dropping' stamp: 'Richo 2/16/2009 16:00'!
wantsDroppedMorph: aMorph event: evt 
	"Slo puedo aceptar instancias que no esten conectadas. Para hacer:
	Tampoco debera
	aceptar si ya tengo algo conectado"
	^ ((self class wantedDroppedMorphClasses includes: aMorph class)
		and: [aMorph isPlugged not]) and: [port isBusy not]! !

PortMorph subclass: #SensorPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

!SensorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/18/2011 12:15'!
myDevice

| sensors strSensors choice |
sensors := NxtSensorMorph allSubclasses asArray.
	strSensors := sensors
				collect: [:each | '  ' , each defaultNameStemForInstances translated , '  '].
	choice := PopUpMenu withCaption: 'Sensor:' translated chooseFrom: strSensors.
	choice = 0
		ifTrue: [^ nil].
	^ (sensors at: choice) new! !

!SensorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:01'!
wantedDroppedMorphClasses
	"Devuelve un array con las clases que pueden conectarse a este puerto"
	^NxtSensorMorph allSubclasses asArray! !

!SensorPortMorph methodsFor: 'as yet unclassified' stamp: 'Richo 2/16/2009 15:55'!
defaultPositions
	^ ({-200 @ 100. -75 @ 200. 75 @ 200. 200 @ 100}
		collect: [:each | each + self center])
		at: port portNumber ! !

!SensorPortMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 23:13'!
letters
^#('1' '2' '3' '4')! !

AlignmentMorph subclass: #LegoNxtMorph
	instanceVariableNames: 'nxt portName controlPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

LegoNxtMorph class
	instanceVariableNames: 'lastPortName'!

LegoNxtMorph class
	instanceVariableNames: 'lastPortName'!

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/13/2012 15:37'!
additionsToViewerCategories
^  #(

		#(#'lego nxt - connection' 
		#(
			#(slot nxtMode 'Let''s you change programming mode. Options are:

* Direct: The script will be executed in the computer and the orders will be transferred to the robot via direct commands. Requires a connection with the robot in order to run.

* Compiled: The script will be compiled and run inside the robot. No communication with the computer is used afterwards.' NxtMode readWrite Player getNxtMode Player setNxtMode:) "Only available if SqueakNxt-EtoysCompiler is loaded"
			#(command connect 'Connects this device' )
			#(command disconnect 'Disconnects this device' )
			#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
			#(slot nxtPort 'Let''s you select the port in which to connect the robot' PENxtPort readWrite Player getNxtPort Player setNxtPort: ) 
		))
		#(#'lego nxt - display' 
		#(
			#(#slot displayX 'Let''s you change the x coordinate in which to write in the display (only available in compiled mode)' Number readWrite Player getDisplayX Player setDisplayX:) 
			#(#slot displayY 'Let''s you change the y coordinate in which to write in the display (only available in compiled mode)' Number readWrite Player getDisplayY Player setDisplayY:) 
			#(#command #displayText: 'Let''s you write text in the display (only available in compiled mode)' String) 
			#(#command #displayNumber: 'Let''s you write a number in the display (only available in compiled mode)' Number) 
			#(#command #resetScreen 'Resets the screen (only available in compiled mode)') 
			#(#command #clearScreen 'Clears the screen (only available in compiled mode)')
		))
		#(#'lego nxt - other stuff' 
		#(
			#(#command #startProgram: 'Starts a program' #String) 
			#(#command #stopProgram 'Stops the running program')
		))
		#(#'lego nxt - sound' 
		#(
			#(#slot volume 'Let''s you change the sound''s volume' Number readWrite Player getVolume Player setVolume:) 
			#(#slot duration 'Let''s you change the sound''s duration' Number readWrite Player getDuration Player setDuration:) 
			#(#command #playTone: 'Plays the given tone' Number) 
			#(#command #playNote: 'Plays the given note' NxtNote) 
			#(#command #playSoundFile: 'Plays a sound file' String) 
			#(#command #stopPlaying 'Stops the current sound')
		))
		"#(#'lego nxt - send/receive' 
		#(
			#(#slot connection '' Number readWrite Player getConnection Player setConnection:) 
			#(#slot mailBox '' Number readWrite Player getMailBox Player setMailBox:) 
			#(#slot msgText '' String readWrite Player getMsgText Player setMsgText:) 
			#(#slot msgNumber '' Number readWrite Player getMsgNumber Player setMsgNumber:) 
			#(#slot msgBoolean '' Boolean readWrite Player getMsgBoolean Player setMsgBoolean:) 
		))"
		#(#'lego nxt - buttons' 
		#(
			#(#slot isPressedEnter 'Shows if the Enter button is currently pressed (only available in compiled mode)' Boolean readOnly Player getIsPressedEnter Player unused) 
			#(#slot isPressedLeft 'Shows if the Left button is currently pressed (only available in compiled mode)' Boolean readOnly Player getIsPressedLeft Player unused) 
			#(#slot isPressedRight 'Shows if the Right button is currently pressed (only available in compiled mode)' Boolean readOnly Player getIsPressedRight Player unused) 
		))
		#(#'lego nxt - timer' 
		#(
			#(#slot currentTick 'Shows the timer''s value' Number readOnly Player getCurrentTick Player unused) 
			#(command resetTimer 'Resets the timer')
		))
)


! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:47'!
defaultNameStemForInstances
^'Nxt Brick' translatedNoop! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/16/2012 16:29'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Brick' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that you can use to communicate with a Lego Mindstorms Nxt' translatedNoop! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:43'!
includeInNewMorphMenu
	^ true! !

!LegoNxtMorph class methodsFor: 'class initialization' stamp: 'Richo 1/25/2011 17:05'!
initialize
	"
	self initialize.
	"
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #NxtMode;
			 symbols: #(direct compiled)).! !

!LegoNxtMorph class methodsFor: 'accessing' stamp: 'Richo 6/8/2011 18:23'!
lastPortName
"
	lastPortName := nil.
"
^lastPortName! !

!LegoNxtMorph class methodsFor: 'accessing' stamp: 'Richo 6/8/2011 18:23'!
lastPortName: aSymbol
lastPortName := aSymbol! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:39'!
batteryLevel
	^ nxt isConnected
		ifTrue: [nxt batteryLevel]
		ifFalse: [0]! !

!LegoNxtMorph methodsFor: 'viewer category filter' stamp: 'Richo 1/6/2011 13:56'!
categoriesForViewer
	^ self validCategories, #(scripting)! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 12/23/2011 18:05'!
connect
	self connectNxtOnPort: portName.
	controlPanel resetDisplay
! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 3/27/2012 09:25'!
connectNxtOnPort: aString 
	"If connection is successfull it makes the nxt beep"
	nxt isConnected
		ifTrue: [^ self].
	[[nxt connectOnPort: aString]
		on: BusyPort
		do: ["Nothing"]]
		on: Error
		do: [:err | self inform: err description].
	nxt isConnected
		ifTrue: [nxt beep]! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 11/11/2009 16:34'!
delete
	self disconnect. 
	super delete
! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 3/27/2012 07:49'!
disconnect
	[nxt disconnect] on: NotConnectedLego do: ["Nothing"].
	controlPanel resetDisplay
! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 07:50'!
initialize
	super initialize.
	self borderWidth: 1;
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded;
		 color: Color black.
	nxt := LegoNxt new.
	self initializePortName.
	self initializeSubmorphs! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 07:50'!
initializePortName
	| availablePorts |
	availablePorts := PESerialPort availablePortsForNxt.
	(availablePorts includes: self class lastPortName)
		ifFalse: [self class lastPortName: availablePorts first].
	portName := self class lastPortName! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 07:51'!
initializeSubmorphs
	self
		addMorphBack: (MotorsBarMorph on: self);
		addMorphBack: (controlPanel := (ControlPanelMorph on: self));
		addMorphBack: (SensorsBarMorph on: self)! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 12/23/2011 18:06'!
isConnected
	^ nxt isConnected! !

!LegoNxtMorph methodsFor: 'mode' stamp: 'Richo 12/23/2011 18:05'!
isUsingCompiledMode
	^ nxt protocol isCompiled! !

!LegoNxtMorph methodsFor: 'mode' stamp: 'Richo 12/23/2011 18:14'!
mode
	^ nxt protocol! !

!LegoNxtMorph methodsFor: 'mode' stamp: 'Richo 12/23/2011 18:38'!
mode: aNxtProtocol
	nxt protocol: aNxtProtocol.
	controlPanel resetDisplay ! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:48'!
newPlayerInstance
	^ SqueakNxtPlayer newUserInstance! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:49'!
nxt
	^ nxt! !

!LegoNxtMorph methodsFor: 'sound' stamp: 'Richo 1/27/2011 13:29'!
playSoundFile: aString 
	nxt isConnected
		ifTrue: [nxt playSoundFile: aString, '.rso']! !

!LegoNxtMorph methodsFor: 'sound' stamp: 'Richo 11/3/2008 16:15'!
playTone: freqNumber 
	nxt isConnected
		ifTrue: [nxt playTone: freqNumber]! !

!LegoNxtMorph methodsFor: 'sound' stamp: 'Richo 1/13/2011 16:01'!
playTone: freqNumber duration: aNumber
	nxt isConnected
		ifTrue: [nxt playTone: freqNumber duration: aNumber]! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:48'!
portName
	^ portName! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:48'!
portName: aSymbol
	self isConnected ifTrue: [self disconnect].
	portName :=  (aSymbol = #'other...'
				ifTrue: [(FillInTheBlank request: 'Port name:' translated)  asSymbol]
				ifFalse: [aSymbol]).
	controlPanel portName: portName.! !

!LegoNxtMorph methodsFor: 'fileOut' stamp: 'Richo 2/16/2010 11:01'!
prepareToBeSaved
	super prepareToBeSaved.
	self disconnect! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:16'!
startProgram: aString 
	nxt isConnected
		ifTrue: [nxt startProgram: aString]! !

!LegoNxtMorph methodsFor: 'sound' stamp: 'Richo 1/13/2011 17:03'!
stopPlayingSound
	nxt isConnected
		ifTrue: [nxt stopPlayingSound]! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 3/15/2010 11:57'!
stopProgram
	nxt isConnected
		ifTrue: [nxt stopProgram]! !

!LegoNxtMorph methodsFor: 'viewer category filter' stamp: 'Richo 1/6/2011 13:55'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

AlignmentMorph subclass: #MotorsBarMorph
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Bars'!

!MotorsBarMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:50'!
on: aLegoNxtMorph 
	^ self basicNew setMain: aLegoNxtMorph;
		 initialize! !

!MotorsBarMorph methodsFor: 'initializing' stamp: 'Richo 9/29/2008 22:14'!
initialize
	super initialize.
	self borderWidth: 0;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #leftToRight;
		 color: Color black.
	self initializeSubmorphs! !

!MotorsBarMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:50'!
initializeSubmorphs
	self
		addMorphBack: (MotorPortMorph port: main nxt portA);
		
		addMorphBack: (MotorPortMorph port: main nxt portB);
		
		addMorphBack: (MotorPortMorph port: main nxt portC);
		 addMorphBack: (Morph new
			color: (Color gray mixed: 0.5 with: Color white);
			 borderColor: Color black;
			 borderWidth: 2;
			 height: 30)! !

!MotorsBarMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:50'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

AlignmentMorph subclass: #SensorsBarMorph
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Bars'!

!SensorsBarMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:51'!
on: aLegoNxtMorph 
^self basicNew setMain: aLegoNxtMorph; initialize! !

!SensorsBarMorph methodsFor: 'initializing' stamp: 'Richo 9/29/2008 23:14'!
initialize
	super initialize.
	self borderWidth: 0;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #leftToRight;
		 color: Color black.
	self initializeSubmorphs! !

!SensorsBarMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:53'!
initializeSubmorphs
	self
		addMorphBack: (SensorPortMorph port: main nxt port1);
		
		addMorphBack: (SensorPortMorph  port: main nxt port2);
		
		addMorphBack: (SensorPortMorph  port: main nxt port3);
		
		addMorphBack: (SensorPortMorph  port: main nxt port4)! !

!SensorsBarMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:52'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

ImageMorph subclass: #NxtPluggableDeviceMorph
	instanceVariableNames: 'connector device attachmentPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

NxtPluggableDeviceMorph subclass: #NxtMotorMorph
	instanceVariableNames: 'automaticBrake lastTimeSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

NxtMotorMorph class
	instanceVariableNames: 'form'!

NxtMotorMorph class
	instanceVariableNames: 'form'!

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/12/2011 11:40'!
additionsToViewerCategories
	^ #(
		#(#'lego nxt' #(
			#(#command #float 'Gradually reduces the power up to 0 from its current speed') 
			#(#command #brake 'Sets the power up to 0 immediately')  
			"#(#command #resetDegrees '')"
			#(slot #automaticBrake 'Sets the power to 0 automatically if it does not receive updated power values after a second' #Boolean #readWrite #Player #getAutomaticBrake #Player #setAutomaticBrake:) 
			#(#slot #power 'Lets you change the power of the motor' #Number #readWrite #Player #getPower #Player #setPower:) 
			"#(#slot #degrees '' #Number #readOnly #Player #getDegrees #unused #unused)"
		))

)
! !

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:47'!
defaultNameStemForInstances
^'Nxt Motor' translatedNoop! !

!NxtMotorMorph class methodsFor: 'form' stamp: 'Richo 10/6/2008 17:52'!
form
	^ form
		ifNil: [
			self initializeForm]! !

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:46'!
includeInNewMorphMenu
	^ true! !

!NxtMotorMorph class methodsFor: 'form' stamp: 'Richo 11/17/2009 13:30'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAUoAAACOCAYAAABXJ0ETAAAABHNCSVQFBQUBSsjp7wAAD+xJ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'! !

!NxtMotorMorph class methodsFor: 'factory' stamp: 'Richo 10/15/2008 15:05'!
myDevice
	^ NxtMotor new! !

!NxtMotorMorph methodsFor: 'attachment point' stamp: 'Richo 3/27/2012 07:53'!
attachmentPointCenter
	^ (-162 @ -19)! !

!NxtMotorMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:53'!
automaticBrake
	^ automaticBrake! !

!NxtMotorMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 07:53'!
automaticBrake: aBoolean
	automaticBrake := aBoolean! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 3/27/2012 07:53'!
brake
	self isPlugged
		ifFalse: [^ self].
	[self device brake] on: NotConnectedLego do: ["Nothing"]! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 3/27/2012 07:54'!
float
	self isPlugged
		ifFalse: [^ self].
	[self device float] on: NotConnectedLego do: ["Nothing"]! !

!NxtMotorMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 08:00'!
initialize
	super initialize.
	automaticBrake := true.
	lastTimeSent := Time millisecondClockValue
	! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 16:11'!
power
	^ [self device power]
		on: Error
		do: [0]! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 3/27/2012 13:15'!
power: aNumber 
	self isPlugged
		ifFalse: [^ self].
	[self device power: aNumber] on: NotConnectedLego do: ["Nothing"].
	lastTimeSent := Time millisecondClockValue! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 3/27/2012 07:54'!
resetRelative: aBoolean 
	self isPlugged
		ifFalse: [^ self].
	[self device resetRelative: aBoolean]
		on: NotConnectedLego do: ["Nothing"]! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 11/27/2008 15:45'!
rotation
	^ [self device rotation]
		on: Error
		do: [-1]! !

!NxtMotorMorph methodsFor: 'stepping' stamp: 'Richo 3/27/2012 08:00'!
step
	"I send #step to super because NxtPluggableDeviceMorph (its superclass)
	controls connections and orientation. Do not remove!!"
	super step.
	self isPlugged
		ifFalse: [^ self].
	(automaticBrake and: [(Time millisecondsSince: lastTimeSent) >= 1000])
		ifTrue: [[self float] on: Error do: ["Nothing"]]! !

!NxtMotorMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:10'!
unplug
	self float.
	super unplug! !

!NxtPluggableDeviceMorph class methodsFor: 'form' stamp: 'Richo 10/15/2008 14:59'!
flippedForm
	^ self form flipBy: #horizontal centerAt: self form center! !

!NxtPluggableDeviceMorph class methodsFor: 'form' stamp: 'Richo 10/15/2008 14:58'!
form
^self subclassResponsibility! !

!NxtPluggableDeviceMorph class methodsFor: 'factory' stamp: 'Richo 10/15/2008 15:00'!
myDevice
^self subclassResponsibility! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 08:29'!
attachmentPoint
	^ attachmentPoint ! !

!NxtPluggableDeviceMorph methodsFor: 'attachment point' stamp: 'Richo 3/27/2012 08:29'!
attachmentPointCenter
	"Each subclass should especify the position of the attachment point (for esthetic purposes)"
	^0@0! !

!NxtPluggableDeviceMorph methodsFor: 'attachment point' stamp: 'Richo 3/27/2012 08:29'!
attachmentPointFlippedCenter
	^ self attachmentPointCenter x negated @ self attachmentPointCenter y! !

!NxtPluggableDeviceMorph methodsFor: 'viewer category filter' stamp: 'Richo 1/6/2011 13:56'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 08:29'!
connector: aConnector
	connector := aConnector! !

!NxtPluggableDeviceMorph methodsFor: 'testing' stamp: 'Richo 3/27/2012 08:29'!
containsPoint: aPoint
	^ (self bounds containsPoint: aPoint) and:
	  [(self imageForm isTransparentAt: aPoint - bounds origin) not]
! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 1/6/2011 12:16'!
controlConnection
	"Very important!! It checks that we can only send messages to the nxt if we are plugged to the brick"
	device isPlugged
		ifFalse: [^ self].
	connector isNil
		ifTrue: [^ self unplug].
	connector isPlugged
		ifFalse: [^ self unplug]! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 3/27/2012 08:33'!
controlOrientation
	"This checks the position of the morph on the screen in relation with 
	the nxt brick and it flips the morph if necessary (for esthetic purposes)"
	connector isNil
		ifTrue: [^ self].
	connector sourceMorph isNil
		ifTrue: [^ self].
	(self center x < (connector sourceMorph center x - 50)
	and: [self image ~= self class flippedForm])
		ifTrue: [self image: self class flippedForm.
			attachmentPoint center: self center  + self attachmentPointFlippedCenter].
	(self center x > (connector sourceMorph center x + 50)
	and: [self image ~= self class form])
		ifTrue: [self image: self class form.
			attachmentPoint center: self center + self attachmentPointCenter]! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 08:33'!
delete
	connector isNil
		ifFalse: [connector delete].
	[self unplug]
		on: NotConnectedLego
		do: ["Nothing"].
	^ super delete! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 08:29'!
device
	^ device! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 08:33'!
initialize
	super initialize.
	device := self class myDevice.
	self image: self class form.
	self initializeAttachmentPoint.! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 08:34'!
initializeAttachmentPoint
	attachmentPoint := PEAttachmentPointMorph new 
				color: Color black;
				borderWidth: 0;
				extent: 1 @ 1;
				center: self center + self attachmentPointCenter.
	self addMorph: attachmentPoint! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/27/2012 08:34'!
initializeToStandAlone
	self initialize! !

!NxtPluggableDeviceMorph methodsFor: 'testing' stamp: 'Richo 2/11/2009 13:43'!
isPlugged
	^ device isPlugged! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 4/13/2012 16:50'!
moveTo: dest 
	self center: dest.
	self top < World top
		ifTrue: [self top: World top].
	self left < World left
		ifTrue: [self left: World left].
	self bottom > (World bottom - 25)
		ifTrue: [self bottom: World bottom - 25].
	self right > World right
		ifTrue: [self right: World right]! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 4/13/2012 16:50'!
moveToOld: dest 
	"It makes a very simple animation of the device moving to the destination (for esthetic purposes)"
	| opuesto adyacente pasosOpuesto pasosAdyacente x y diff maxPasos |
	x := self center x.
	y := self center y.
	diff := self center - dest.
	opuesto := diff y abs.
	adyacente := diff x abs.
	maxPasos := 10.
	pasosOpuesto := opuesto / maxPasos * diff y sign.
	pasosAdyacente := adyacente / maxPasos * diff x sign.
	[maxPasos
		timesRepeat: [x := x - pasosAdyacente.
			y := y - pasosOpuesto.
			self center: x rounded @ y rounded.
			(Delay forMilliseconds: 1) wait]]
		forkNamed: self class asString, ' moveTo: ' , dest asString! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 2/11/2009 14:25'!
newPlayerInstance
	^ SqueakNxtPlayer newUserInstance! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 1/6/2011 12:20'!
step
	self controlConnection;
		controlOrientation.! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 10/21/2008 15:42'!
stepTime
	^ 200! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 1/6/2011 12:23'!
unplug
	self isPlugged ifFalse: [^self].
	device unplug! !

!NxtPluggableDeviceMorph methodsFor: 'viewer category filter' stamp: 'Richo 3/27/2012 08:29'!
validCategories
	^(self class additionsToViewerCategories collect: [:each| each first])! !

NxtPluggableDeviceMorph subclass: #NxtSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

NxtSensorMorph class
	instanceVariableNames: 'form'!

NxtSensorMorph class
	instanceVariableNames: 'form'!

NxtSensorMorph subclass: #LightSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/12/2011 11:38'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #active 'Indicates if the light sensor is active' #Boolean #readWrite #Player #getActive #Player #setActive:) #(#slot #value 'Shows the raw value of the light sensor' #Number #readOnly #Player #getValue #unused #unused))) )! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:47'!
defaultNameStemForInstances
	^ 'Nxt Light Sensor' translatedNoop! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:29'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABY9J
REFUeF7lnT92ozAQxild7hFcUrrkCC4pU+4RUlKmTLlHcOnSpcs9To6Qjs3Yi6MMGmnQP7A+
3tMjim0wX778GI2E1IRtuxG/TCXrhi9wIeHxBS0kvPvgXdeNr6+vcCWT6PIBD4fDeLlcxo+P
D9jiFz6B2IdDN57PZ+cXode34kTfd80vfITghA/phGah99XEZI5NyWQRotudvewk9RcuvqxH
pLPpRMRw/Gjkfi+LEN3vbKpLJ9/v92Pf9+PxeByHYRhPp9OjnI2fn6VO1zFdj094M4BQiq5j
tnRCEphOZH75GutkKo3oMgEcgnOxpYMMr8NTO3lpna5Xw3S7XoLYmg+3bVutkzV1un6XbuR4
QXT3jcAWZ+73bfVO1tRtZuWxv1dwH7fRnW3W6d7lu/ctEtzmbnxnz6MZl4aLBOev9cce39mK
6MVk+bzlLcTdLnfjO3tel7Ay11H4y/A3PtiN72xrnUctMimUgt8aN/hOFuuc5XILXSk4vpPd
dUoD6IIPpeD4Tl4WrUQLju9kdz2Lw9dyEt0/puydlKk0s3tbY3iYwwu34Eg8V3ZOU/AZrnBy
rMg255fIzz8Vw0kQW/bNmg7uqTSzve9z5EB8hjuyblzk67AbP8/N+HlqxD29p9s3Dse3+Ax3
OZucexNzYXE5PpfTN89wqeeEHHp3dON1tG/v6hKEYrgtjzyJHeJot9vdokMw3Cn2Kf2e2J6b
6ZtluK3xksPZvEiip3L6Zhluu+hcztY4nWL1ahlOPUb8gh/hXqFiY3qKcTWbZDgx8wdK2jLO
NvcU/dhcXiXD13a3K06vkuGxUYkVB/2dzUudnnoE2SYZ/sPdb7voCCP0eDaWx7ZAN8dw7gCt
E125EVvOJbQlSt+vKoZzB4Sy9s/1ffz7eb2V96+fD10b7HTzj/lweC0MD3E4F/su9OW2v/7f
U/338BIU15tYie0p2hzDTQdosoDkVPP8JOrkbF5emODa6Mf8D6qa4RrWcpzYnG3WQ1jOHV4t
wzUO51GE5O6phOTRrQ6vkeEqhx9/Ovz9+iYynG6kKRwOzXDeOKFoRMvwkBbnKgw3HwLlj0uU
ZjjtKdfCb5yc4eT81ggNl7RgczKcj0oWx4dLpTTDpRYmOZ0cTeK3XRvV4szJcMeTyfpBNSUZ
/p3d282cnqqlmZPh0YKvwXBN32RMj1FOhgc8e79bneFS9GIOAorJj+dleOR8KWswvGRePD3D
IwVfi+E593kZHuvwlRlO0Qd9rmsZv9vwnqO8DE/g8LUY7rphpoxS8BluyRqm7PnBZ7im77H5
+v2v70L10HEu+Az39PhwsSXRo7KFyAw3W5jdzi72VGYNIXyGx2ULB4/g9HpMnyk+w086nEhY
wWd4pMN9SOlSORyZ4Tz+vgqiX3fN5vo0n5LhPB9OLraxnLs7qtcePQ7XDHOzio3P8PBciuY5
zNjj4jN8Qc8Pxd1LnI3P8ICs4dQJsXTULD7D8fPh28yHF+vxwWd4OYdviuGP5xnx+zTLMDwl
4/AZrhA8dt5CfIZHhIb4DM/CcOHGic/wXAyfC87/7fAZ/l2fz9WVaHmw0PnDa2d4wjXZ/FNe
oDPcPuFO4kXwlsblNTN8PktGpiUelzi9VoZncLd7QTyt02tluH1WuswLmWrmG6mR4Rnd7Rfd
F73UyHD7tK2F10aW5nqtieHy4yXZN/dcr+YyBjUwnKIR9xy5RTb8ZR4Lio0v+gpiI4v/tFv+
WZxvs+4fe3Sh54KXXFGqwd3KraaCL7jF4TlXI8EXvBDDpzq+4PgMx2c4PsPxGY7PcHyG4zMc
n+H4DMcXHJ/h+AzHZzg+w/EZjs9wfIbjMxyf4fhIwWc4PsPxGY7PcHyG4zMcn+H4DH8iwWkU
Kw2szLXHF5wJjj9UDV/wpNs/44yFQ/nAYOUAAAAASUVORK5CYII='! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:16'!
myDevice
	^ LightSensor new! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:20'!
active
	^ self device isActive! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:19'!
active: aBoolean 
	aBoolean
		ifTrue: [self device setActive]
		ifFalse: [self device setInactive]! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 11/26/2008 14:05'!
value
	^ (self normalizedValue * 100 / 1023) asInteger! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/13/2012 14:59'!
additionsToViewerCategoryAdvanced
	^ #(
		#'lego nxt-advanced' 
		#(
			#(slot rawValue 'Sensor''s raw A/D value (device dependent)' Number readOnly Player getRawValue unused unused)
			#(slot normalizedValue 'Sensor''s normalized A/D value (type dependent; range: 0 - 1023)' Number readOnly Player getNormalizedValue unused unused)
			#(slot scaledValue 'Sensor''s scaled value (mode dependent)' Number readOnly Player getScaledValue unused unused)
			)
		)! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:55'!
form
	^ form
		ifNil: [self initializeForm]! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:56'!
includeInNewMorphMenu
	^ true! !

!NxtSensorMorph methodsFor: 'attachment point' stamp: 'Richo 11/10/2009 13:03'!
attachmentPointCenter
^self bottomCenter - self center - (0@2)! !

!NxtSensorMorph methodsFor: 'accessing' stamp: 'Richo 3/5/2009 15:44'!
normalizedValue
	[[^ self device normalizedValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'accessing' stamp: 'Richo 3/5/2009 15:44'!
rawValue
	[[^ self device rawValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'accessing' stamp: 'Richo 3/5/2009 15:44'!
scaledValue
	[[^ self device scaledValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'viewer category filter' stamp: 'Richo 3/27/2012 08:26'!
validCategories
	"The sensors have a generic category with raw, normalized and scaled values
	and a specific for each sensor type.
	This method makes sure we accept both of them."
	^super validCategories,
		(NxtSensorMorph class selectors asArray
			select: [:sel | sel beginsWith: #additionsToViewerCategory]
			thenCollect: [:sel | (NxtSensorMorph perform: sel) first])! !

!NxtSensorMorph methodsFor: 'accessing' stamp: 'Richo 3/27/2012 08:14'!
value
	^ self rawValue! !

NxtSensorMorph subclass: #SoundSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/12/2011 11:44'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #audible 'If you set this slot to true the sensor will only read sounds audible to humans, otherwise it will also read inaudible sounds' #Boolean #readWrite #Player #getAudible #Player #setAudible:) #(#slot #value 'Shows the current value of this sensor' #Number #readOnly #Player #getValue #unused #unused))) )! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:48'!
defaultNameStemForInstances
	^ 'Nxt Sound Sensor' translatedNoop! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:32'!
initializeForm
^form := PEUtilities formFromEncodedPNG: 
 'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABvpJ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'! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:57'!
myDevice
	^ SoundSensor new! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/27/2012 08:14'!
audible
	^ self device isAudible! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/27/2012 08:15'!
audible: aBoolean
	aBoolean
		ifTrue:[self device setAudible]
		ifFalse: [self device setInaudible]! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/26/2008 14:05'!
value
	^ (self normalizedValue * 100 / 1023) asInteger! !

NxtSensorMorph subclass: #SwitchSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/12/2011 11:44'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #isPressed 'Indicates if the switch sensor button is pressed' #Boolean #readOnly #Player #getIsPressed #unused #unused))) )! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:48'!
defaultNameStemForInstances
	^ 'Nxt Switch Sensor' translatedNoop! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:33'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABi5J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'! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:22'!
myDevice
	^ SwitchSensor new! !

!SwitchSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/25/2008 14:37'!
isPressed
	^ self normalizedValue < 500! !

NxtSensorMorph subclass: #UltrasonicSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys'!

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 3/27/2012 08:28'!
additionsToViewerCategories
	^
	#(
		#(#'lego nxt'
			#(
			#(slot distanceCm 'Shows the distance in centimeters between the sensor and the object that is looking' Number readOnly Player getDistanceCm unused unused)
			)
		)
	)
! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 10:48'!
defaultNameStemForInstances
	^ 'Nxt Ultrasonic Sensor' translatedNoop! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:34'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAKwAAABkCAYAAAAbitsBAAAABHNCSVQFBQUBSsjp7wAACIVJ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'! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 3/27/2012 08:27'!
myDevice
	^ UltrasonicSensor new! !
SqueakNxtPlayer initialize!
LegoNxtMorph initialize!
